"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Scoped = void 0;
var Errors_1 = require("../Errors");
var Scoped = /** @class */ (function () {
    function Scoped(name, factory) {
        Object.defineProperty(this, "factory", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "name", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.name = name;
        this.factory = factory;
    }
    Object.defineProperty(Scoped.prototype, "provide", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (context) {
            var lastSingleton = context.lastSingleton, instances = context.instances, proxy = context.proxy;
            if (lastSingleton)
                throw new Errors_1.SingletonScopedDependencyError(lastSingleton.name, this.name);
            if (!instances[this.name])
                instances[this.name] = this.factory(proxy, context);
            return instances[this.name];
        }
    });
    Object.defineProperty(Scoped.prototype, "clone", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function () {
            return new Scoped(this.name, this.factory);
        }
    });
    Object.defineProperty(Scoped.prototype, "Lifetime", {
        get: function () {
            return Scoped;
        },
        enumerable: false,
        configurable: true
    });
    return Scoped;
}());
exports.Scoped = Scoped;
