"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Singleton = void 0;
var Singleton = /** @class */ (function () {
    function Singleton(name, factory) {
        Object.defineProperty(this, "factory", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "isSingleton", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
        Object.defineProperty(this, "name", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.name = name;
        this.factory = factory;
    }
    Object.defineProperty(Singleton.prototype, "provide", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (context) {
            var instances = context.root.instances, proxy = context.proxy;
            if (!instances[this.name])
                instances[this.name] = this.factory(proxy, context);
            return instances[this.name];
        }
    });
    Object.defineProperty(Singleton.prototype, "clone", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function () {
            return new Singleton(this.name, this.factory);
        }
    });
    Object.defineProperty(Singleton.prototype, "Lifetime", {
        get: function () {
            return Singleton;
        },
        enumerable: false,
        configurable: true
    });
    return Singleton;
}());
exports.Singleton = Singleton;
