import { ILifetime } from '../Lifetime';
import { IServiceProvider } from '../ServiceProvider';
import { MockStrategy, ProviderMock } from './mockUtils';
import { DependencyOptions, LifetimeConstructor, Selector, Stateful, StatefulDependencyOptions } from './types';
export declare class ServiceCollection<E = {}> {
    private readonly self;
    private readonly lifetimes;
    constructor(other?: ServiceCollection, lifetime?: ILifetime<any, E>);
    addMultiple<T>(func: (services: ServiceCollection<E>) => ServiceCollection<T>): ServiceCollection<T>;
    addStateful<T, P, K extends string>(name: K & (K extends keyof E ? never : any), Dependency: StatefulDependencyOptions<T, P, {
        [key in ((keyof E) | K)]: key extends keyof E ? E[key] : Stateful<P, T>;
    }>): ServiceCollection<{ [key_1 in keyof { [key in K | keyof E]: key extends keyof E ? E[key] : Stateful<P, T>; }]: { [key in K | keyof E]: key extends keyof E ? E[key] : Stateful<P, T>; }[key_1]; }>;
    addSingleton<T, K extends string>(name: K & (K extends keyof E ? never : any), Dependency: DependencyOptions<T, E>): ServiceCollection<{ [key_1 in keyof { [key in keyof E | K]: key extends keyof E ? E[key] : T; }]: { [key in keyof E | K]: key extends keyof E ? E[key] : T; }[key_1]; }>;
    addScoped<T, K extends string>(name: K & (K extends keyof E ? never : any), Dependency: DependencyOptions<T, E>): ServiceCollection<{ [key_1 in keyof { [key in keyof E | K]: key extends keyof E ? E[key] : T; }]: { [key in keyof E | K]: key extends keyof E ? E[key] : T; }[key_1]; }>;
    addTransient<T, K extends string>(name: K & (K extends keyof E ? never : any), Dependency: DependencyOptions<T, E>): ServiceCollection<{ [key_1 in keyof { [key in keyof E | K]: key extends keyof E ? E[key] : T; }]: { [key in keyof E | K]: key extends keyof E ? E[key] : T; }[key_1]; }>;
    add<T, K extends string>(Lifetime: LifetimeConstructor, name: K & (K extends keyof E ? never : any), Dependency: DependencyOptions<T, E>): ServiceCollection<{ [key_1 in keyof { [key in keyof E | K]: key extends keyof E ? E[key] : T; }]: { [key in keyof E | K]: key extends keyof E ? E[key] : T; }[key_1]; }>;
    get<T>(selector: Selector<T, E>): ILifetime<T, E> | undefined;
    remove<T, K extends string>(selector: Selector<T, E>): ServiceCollection<{ [key_1 in keyof { [key in keyof Omit<E, K>]: key extends keyof E ? E[key] : T; }]: { [key in keyof Omit<E, K>]: key extends keyof E ? E[key] : T; }[key_1]; }>;
    replace<T>(selector: Selector<T, E>, Dependency: DependencyOptions<T, E>): this;
    build(): IServiceProvider<E>;
    buildMock(mock?: MockStrategy | ProviderMock<E>, defaultMockType?: MockStrategy): IServiceProvider<E>;
    private extractFactory;
    private cloneLifetimes;
}
