import { DependencyInfo, ILifetime } from '../Lifetime';
import { Key, LifetimeCollection, Selector } from '../ServiceCollection';
import { IServiceProvider } from './IServiceProvider';
import { ServiceProvider } from './ServiceProvider';
declare type Falsy = null | undefined | false | 0 | '';
export declare class ScopedServiceProvider<E = any> implements IServiceProvider<E> {
    readonly instances: Record<Key<any>, any>;
    readonly root: ServiceProvider<E>;
    private _isDone;
    private readonly lookup;
    private readonly ordered;
    constructor(parent: IServiceProvider<E>, lifetime?: ILifetime);
    readonly lifetimes: LifetimeCollection<E>;
    readonly proxy: E;
    readonly parent: IServiceProvider<E>;
    private _lastSingleton?;
    get isDone(): boolean;
    get depth(): number;
    get lastSingleton(): DependencyInfo<E> | undefined;
    using(action: (provider: E) => any): void;
    provide<T>(selector: Selector<T, E>): T;
    enter(lifetime: ILifetime | Falsy): ScopedServiceProvider<E>;
    private _enter;
    private getLifetime;
}
export {};
