import { Key, Selector, ServiceCollection } from './ServiceCollection';
import { IServiceProvider } from './ServiceProvider';
export declare type PropertyOf<E> = Required<{
    [key in keyof E]: key & Key<E>;
}>;
export declare const Services: () => ServiceCollection<{}>;
export declare type Dependency<K extends string, T> = {
    [key in K]: T;
};
export declare type ServiceProviderOf<T extends IServiceProvider> = T['proxy'];
export declare type ServiceCollectionOf<T extends ServiceCollection<any>> = ServiceProviderOf<ReturnType<T['build']>>;
export declare type FunctionOf<T extends (() => ServiceCollection<any>) | (() => IServiceProvider)> = ReturnType<T> extends IServiceProvider ? ServiceProviderOf<ReturnType<T>> : ReturnType<T> extends ServiceCollection<any> ? ServiceCollectionOf<ReturnType<T>> : never;
export declare const propertyOf: <T>() => Required<{ [key in keyof T]: key & keyof T & string; }>;
export declare const proxyOf: <E>(self: IServiceProvider<E>) => E;
export declare function extractSelector<T, E>(options: Selector<T, E>): Key<E>;
